require 'package'
class Re6stnet < Package
  description 'Resilient, Scalable, IPv6 Network'
  homepage 'https://re6st.nexedi.com/'
  version '0.573'
  compatibility 'all'
  source_url 'https://lab.nexedi.com/nexedi/chromebrew-buildout-re6st/repository/archive.tar.bz2?ref=e2271496c9138c725c07a39dd6caec2b2785a183'
  source_sha256 'dfc7b598162af4b7b5c869347f8a7f4ac7e2c0f0e3166f6529eb38ff94c85aaf'

  binary_url ({
    x86_64: 'https://softinst132325.host.vifib.net/public/re6stnet-0.573-chromeos-x86_64.tpxz',
  })
  binary_sha256 ({
    x86_64: '89484d1df0963e22936d6c08af9a73f46e6c29c960f3db632e9cc1c84dee1f18',
  })

  depends_on 'python27' => :build
  depends_on 'filecmd' => :build
  depends_on 'libiconv' => :build
  depends_on 'glibc'

  @re6st_dir = "#{CREW_PREFIX}/opt/re6st"

  def self.build
    system "mkdir -p #{@re6st_dir}/bin/ #{@re6st_dir}/tmp-networkcached/bin"
    system "cp buildout.cfg #{@re6st_dir}"
    system "cp bin/* #{@re6st_dir}/bin/"
    system "gcc shill_wrapper.c -o #{@re6st_dir}/bin/shill_wrapper -ldl -Wall -fPIC -pie"
    system "cp bin/bootstrap #{@re6st_dir}/tmp-networkcached/bin/"
    system "cp networkcached.cfg #{@re6st_dir}/tmp-networkcached/buildout.cfg"
    system "cd #{@re6st_dir}/tmp-networkcached && ./bin/bootstrap && MAKEFLAGS=-j ./bin/buildout"
    system "cd #{@re6st_dir} && MAKEFLAGS=-j SSL_CERT_DIR=/etc/ssl/certs tmp-networkcached/bin/buildout"
  end

  def self.install
    system "mkdir -p #{CREW_DEST_PREFIX}/opt/"
    system "cp -r #{@re6st_dir} #{CREW_DEST_DIR}#{@re6st_dir}"
    system "rm -rf #{CREW_DEST_DIR}#{@re6st_dir}/download-cache"
  end

  def self.postinstall
    system "ln -fs #{@re6st_dir}/bin/grandenet #{CREW_PREFIX}/sbin/grandenet"
    system "ln -fs #{@re6st_dir}/bin/shill.sh #{CREW_PREFIX}/sbin/shill.sh"
    system "ln -fs #{@re6st_dir}/bin/shill_wrapper #{CREW_PREFIX}/sbin/shill_wrapper"
    system "ln -fs #{@re6st_dir}/bin/re6stnet #{CREW_PREFIX}/sbin/re6stnet"
    system "ln -fs #{@re6st_dir}/bin/re6st-conf #{CREW_PREFIX}/bin/re6st-conf"
    system "ln -fs #{@re6st_dir}/bin/re6st-registry #{CREW_PREFIX}/bin/re6st-registry"
    puts "To initiate re6stnet, run #{CREW_PREFIX}/sbin/grandenet"
  end
end
